
/*
	blink-232
				for ForCy-AVR (RS-232C)
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>


static unsigned int     tm_clk, speed;

#define	sw()	(~(PIND>>2)&3)
#define led(x)	(PORTD=((~(x))<<4)|0x0f)

static unsigned char	light;


ISR( TIMER0_COMPA_vect )
{

    if( --tm_clk==0 ) {
        tm_clk  = speed;

        //  2*speed mSec
        {
			light	^= 0xff;
			led(light);

			switch( sw() ) {
				case 1:	speed	= 50;	break;
				case 2:	speed	= 500;	break;
				case 3:	speed	= 150;	break;
			}
        }
    }
}

static void timer_init()
{

	OCR0A   = 249;          // 2mS
	TCCR0A  = 2;
	TCCR0B  = 3;            // 1/64
	TIMSK0  = (1<<OCIE0A);

    tm_clk  = speed;
}

int main(void)
{

    wdt_enable(WDTO_15MS);

	speed	= 150;
    timer_init();

	DDRD    = 0xfa;
	light	= 5;

    sei();
    for(;;)
    	wdt_reset();

    return 0;
}

