
/*
	blink-usb
				for ForCy-USB
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>


#define CLK_PER_SEC 500
static unsigned int     tm_clk, tm_sec;

#define	sw()	(~(PINC>>4)&3)

static unsigned char    scan, led[8];


ISR( TIMER0_COMPA_vect )
{

    if( --tm_clk==0 ) {
        tm_clk  = CLK_PER_SEC;
        tm_sec++;

        //  1 Sec
        {
            unsigned char   i, j;
            
            for( i=0; i<8; i++ )
                led[i]  ^= 0xff;  	//	Srbg]
 
 			j	= sw();
			if( j ) {
				j	= (unsigned char)(j==1? 0:tm_sec);
				for( i=0; i<8; i++ )
					led[i]	= j;
			}
        }
   }

    //  2 mS
    {
        unsigned char   sc;

        PORTB   = 0;
        scan    = ( scan + 1 ) & 7;
        sc      = ~(1<<scan);
        PORTC   = 0x30 | (sc & 0x0f);
        PORTD   = sc & 0xf0;
        PORTB   = led[scan];
    }
}


static void timer_init()
{

	OCR0A   = 249;          // 2mS
	TCCR0A  = 2;
	TCCR0B  = 3;            // 1/64
	TIMSK0  |= (1<<OCIE0A);

    tm_clk  = CLK_PER_SEC;
    tm_sec  = 0;
}


int main(void)
{

	wdt_enable(WDTO_15MS);
    timer_init();

	// LED XL SW1,2 ̃|[gݒ
	DDRB    = 0xff;
	DDRC    = 0x0f;
	DDRD    = 0xfa;

    sei();
    for(;;)
        wdt_reset();

    return 0;
}

