
/*
	music-232
				for ForCy-AVR (RS-232C)
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>


//	̋Ȃł傤H
static char PROGMEM music[] = "fhjfmmmjhhmmhhfcjjjfeee   cceefhaaffhjkkkjhfhhh   fhjfmmmjhhmmhhfcccefaaa   cceefhaaffhjkkkjhffff   jkm m m m momkj j j j jkjhf f fec e efh hjhjh    jkm m m m momkj j j jkjhfec cefha f hjhhh hffff   ";

static unsigned int PROGMEM tone[17] = {
	557, 526, 496, 468, 442, 417, 394, 375, 351, 331, 313, 295, 279, 263, 248, 234, 221 };

static unsigned char	wait, i, off;


ISR( TIMER0_COMPA_vect )
{
	char	n;

	if( --wait )
		return;
	wait	= 125;				// 250mS Ɏs

	n	= pgm_read_byte(music+i++);
	if( n ) {
		if( n==' ' ) {
			TCCR1A	= 0;			// stop
			off	= 1;
		}
		else {
			OCR1A	= pgm_read_word(tone+n-'a');
			if( off ) {
				TCCR1A	= 0x41;		// start
				off	= 0;
			}
		}
	}
	else
		i	= 0;				// JԂ
}


static void timer_init()
{

	OCR0A   = 249;          // 2mS
	TCCR0A  = 2;
	TCCR0B  = 3;            // 1/64
	TIMSK0  = (1<<OCIE0A);

	DDRB	= 0x02;			// PORTB1iTimer1ój
	TCCR1B	= 0x12;
	TCCR1A	= 0x41;
}


int main(void)
{

	wdt_enable(WDTO_15MS);
    timer_init();

	wait	= 0;
	i		= 0;
	off		= 0;

    sei();
    for(;;)
    	wdt_reset();

    return 0;
}

